
.nolist
.include "m8def.inc"
.list

.def rem24L =r6 
.def rem24M =r7 
.def rem24H =r8 
.def result24L =r9 
.def result24M =r10 
.def result24H =r11 
.def dvd24L =r9 
.def dvd24M =r10 
.def dvd24H =r11 
.def dvr24L =r12 
.def dvr24M =r13 
.def dvr24H =r14 
.def rLoopCnt1=r22

.def	mpr1 = r16
.def	PWM_val = r20
.def	FREQ_sel = r21

.org 	0x00
				rjmp	start
.org	ADCCaddr				; ADC Conversion Complete
				rjmp	ADC_int

start:
			ldi		mpr1,low(RAMEND)
			out		spl,mpr1
			ldi		mpr1,high(RAMEND)
			out		sph,mpr1

			sbi		ddrb,pb2


			ldi		mpr1,(0<<REFS1|1<<REFS0|1<<ADLAR)
			out		admux,mpr1
			ldi		mpr1,(1<<ADEN|1<<ADSC|0<<ADFR|1<<ADIE|1<<ADPS2|1<<ADPS1|1<<ADPS0)
			out		adcsra,mpr1

			ldi		mpr1,(0<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|1<<WGM10)
			out		TCCR1A,mpr1
			ldi		mpr1,(1<<WGM12|1<<WGM13|0<<CS12|0<<CS11|1<<CS10)
			out		TCCR1B,mpr1

			sei

praca:		
			
			cli	
			tst		FREQ_sel
			brne	praca_00
			inc		FREQ_sel			
praca_00:	mul		FREQ_sel,PWM_val
			mov		dvd24H,r1
			mov		dvd24M,r0
			clr		mpr1
			mov		dvd24L,mpr1
			mov		dvr24H,mpr1
			mov		dvr24M,mpr1
			ldi		mpr1,0xff
			mov		dvr24L,mpr1

			rcall	div24u

			out		ICR1H,FREQ_sel
			clr		mpr1
			mov		zh,result24M
			mov		zl,result24L
			out		OCR1AH,FREQ_sel
			out		OCR1AL,mpr1
			out		OCR1BH,zh
			out		OCR1BL,zl
						
			sei
			nop
			nop		
			rjmp	praca

ADC_int:	
			push	mpr1
			in		mpr1,SREG
			push	mpr1

			in		mpr1,ADMUX
			andi	mpr1,0b00000111
			tst		mpr1
			breq	ADC_PWMselect

			in		mpr1,ADMUX
			andi	mpr1,0b11111000
			out		ADMUX,mpr1

			in		FREQ_sel,ADCH

ADC_int_end:
			sbi		ADCSRA,ADSC
			pop		mpr1
			out		SREG,mpr1
			pop		mpr1
			reti

ADC_PWMselect:			
			in		mpr1,ADMUX
			ori		mpr1,0b00000001
			out		ADMUX,mpr1

			in		PWM_val,ADCH
			rjmp	ADC_int_end

; ----

div24u: 	clr rem24L 			;clear remainder Low byte 
			clr rem24M 			;clear remainder mid byte 
			sub rem24H,rem24H 	;clear remainder High byte and carry 
			ldi rLoopCnt1,25 	;init loop counter 

d16u_1: 	rol dvd24L 			;shift left dividend 
			rol dvd24M 
			rol dvd24H 
			dec rLoopCnt1 		;decrement counter 
			brne d16u_2 		;if done 
			ret 				; return 

d16u_2: 	rol rem24L 			;shift dividend into remainder 
			rol rem24M 
			rol rem24H 
			sub rem24L,dvr24L 	;remainder = remainder - divisor 
			sbc rem24M,dvr24M 	; 
			sbc rem24H,dvr24H 
			brcc d16u_3 		;if result negative 
			add rem24L,dvr24L 	; restore remainder 
			adc rem24M,dvr24M 
			adc rem24H,dvr24H 
			clc 				; clear carry to be shifted into result 
			rjmp d16u_1 		;else 
d16u_3: 	sec 				; set carry to be shifted into result 
			rjmp d16u_1 
